diff --git a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
index 06d0e3f6d5..0c1e03f044 100644
--- a/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
+++ b/usr/src/uts/common/io/cxgbe/t4nex/t4_sge.c
@@ -1962,94 +2307,114 @@ free_fl_bufs(struct sge_fl *fl)
 }
 
 /*
- * Note that fl->cidx and fl->offset are left unchanged in case of failure.
+ * Attempt to create an mblk representing the payload stored at the current
+ * offset (fl->offset) in the current FL buffer (fl->cidx_sdesc). If the length
+ * of the payload is less than fl->copy_threshold, then allocable a new
+ * mblk/dblk to hold the contents and copy it over. Otherwise, attempt to
+ * desballoc() the payload. If there is a failure to allocate, then restore the
+ * eq->tse_cidx and fl->offset to their original value that they had upon
+ * entering this function.
  */
 static mblk_t *
-get_fl_payload(struct adapter *sc, struct sge_fl *fl, uint32_t len_newbuf,
-    int *fl_bufs_used)
+t4_fl_get_payload(struct sge_fl *fl, uint32_t len, bool newbuf)
 {
-	struct mblk_pair frame = {0};
-	struct rxbuf *rxb;
-	mblk_t *m = NULL;
-	uint_t nbuf = 0, len, copy, n;
-	uint32_t cidx, offset, rcidx, roffset;
+	struct adapter *sc = t4_fl_to_iq(fl)->tsi_adapter;
+	t4_sge_eq_t *eq = &fl->eq;
+	mblk_t *mp = NULL;
+	mblk_t *head = NULL, **tailp = &head;
+	uint_t bufs_consumed = 0;
 
+	FL_LOCK(fl);
 	/*
 	 * The SGE won't pack a new frame into the current buffer if the entire
 	 * payload doesn't fit in the remaining space.  Move on to the next buf
 	 * in that case.
 	 */
-	rcidx = fl->cidx;
-	roffset = fl->offset;
-	if (fl->offset > 0 && len_newbuf & F_RSPD_NEWBUF) {
+	const uint16_t rcidx = eq->tse_cidx;
+	const uint_t rcidx_sdesc = fl->cidx_sdesc;
+	const uint32_t roffset = fl->offset;
+	uint_t credits_avail = 0;
+
+	if (fl->offset > 0 && newbuf) {
+		/*
+		 * The device has moved onto the next buffer. Reset our offset
+		 * into the current buffer and advanced the driver's cidx, which
+		 * may have freed up an EQ host credit to be refilled by the
+		 * driver.
+		 */
 		fl->offset = 0;
-		if (++fl->cidx == fl->cap)
-			fl->cidx = 0;
-		nbuf++;
+		credits_avail += t4_fl_advance_cidx(fl);
+		bufs_consumed++;
 	}
-	cidx = fl->cidx;
-	offset = fl->offset;
 
-	len = G_RSPD_LEN(len_newbuf);	/* pktshift + payload length */
-	copy = (len <= fl->copy_threshold);
-	if (copy != 0) {
-		frame.head = m = allocb(len, BPRI_HI);
-		if (m == NULL) {
-			fl->allocb_fail++;
+	const bool do_copy = (len <= fl->copy_threshold);
+	if (do_copy) {
+		mp = allocb(len, 0);
+		if (mp == NULL) {
+			fl->stats.copy_fail++;
 			DTRACE_PROBE1(t4__fl_alloc_fail, struct sge_fl *, fl);
-			fl->cidx = rcidx;
-			fl->offset = roffset;
-			return (NULL);
+			goto restore;
 		}
+		*tailp = mp;
+		tailp = &mp->b_cont;
 	}
 
-	while (len) {
-		rxb = fl->sdesc[cidx].rxb;
-		n = min(len, rxb->buf_size - offset);
+	uint_t offset = fl->offset;
+	while (len != 0) {
+		struct rxbuf *rxb =
+		    t4_fl_sdesc(fl, eq->tse_cidx, fl->cidx_sdesc)->rxb;
+		const uint_t copy_len = MIN(len, rxb->buf_size - offset);
 
-		(void) ddi_dma_sync(rxb->dhdl, offset, n,
-		    DDI_DMA_SYNC_FORKERNEL);
+		(void) ddi_dma_sync(rxb->dhdl, 0, 0, DDI_DMA_SYNC_FORKERNEL);
 
-		if (copy != 0)
-			bcopy(rxb->va + offset, m->b_wptr, n);
-		else {
-			m = desballoc((unsigned char *)rxb->va + offset, n,
-			    BPRI_HI, &rxb->freefunc);
-			if (m == NULL) {
-				fl->allocb_fail++;
+		if (do_copy) {
+			bcopy(rxb->va + offset, mp->b_wptr, copy_len);
+			fl->stats.copy++;
+		} else {
+			mp = desballoc((unsigned char *)rxb->va + offset,
+			    copy_len, 0, &rxb->freefunc);
+			if (mp == NULL) {
+				fl->stats.wrap_fail++;
 				DTRACE_PROBE1(t4__fl_alloc_fail,
 				    struct sge_fl *, fl);
-				if (frame.head)
-					freemsgchain(frame.head);
-				fl->cidx = rcidx;
-				fl->offset = roffset;
-				return (NULL);
+				goto restore;
 			}
 			atomic_inc_uint(&rxb->ref_cnt);
-			if (frame.head != NULL)
-				frame.tail->b_cont = m;
-			else
-				frame.head = m;
-			frame.tail = m;
+			*tailp = mp;
+			tailp = &mp->b_cont;
+			fl->stats.wrap++;
 		}
-		m->b_wptr += n;
-		len -= n;
-		offset += roundup(n, sc->sge.fl_align);
-		ASSERT(offset <= rxb->buf_size);
+		mp->b_wptr += copy_len;
+		len -= copy_len;
+		offset += roundup(copy_len, sc->sge.fl_align);
+
+		ASSERT3U(offset, <=, rxb->buf_size);
 		if (offset == rxb->buf_size) {
 			offset = 0;
-			if (++cidx == fl->cap)
-				cidx = 0;
-			nbuf++;
+			credits_avail += t4_fl_advance_cidx(fl);
+			bufs_consumed++;
 		}
 	}
-
-	fl->cidx = cidx;
 	fl->offset = offset;
-	(*fl_bufs_used) += nbuf;
+	ASSERT3U(credits_avail, <=, eq->tse_qsize);
+	eq->tse_avail += credits_avail;
+	/* We can't consume more than are available. */
+	ASSERT3U(bufs_consumed, <=, fl->bufs_avail);
+	fl->bufs_avail -= bufs_consumed;
+
+	FL_UNLOCK(fl);
+
+	ASSERT(head != NULL);
+	return (head);
+
+restore:
+	eq->tse_cidx = rcidx;
+	fl->cidx_sdesc = rcidx_sdesc;
+	fl->offset = roffset;
+	FL_UNLOCK(fl);
+	freemsgchain(head);
 
-	ASSERT(frame.head != NULL);
-	return (frame.head);
+	return (NULL);
 }
 
 /*
@@ -2058,7 +2423,7 @@ get_fl_payload(struct adapter *sc, struct sge_fl *fl, uint32_t len_newbuf,
  * of immediate data.
  */
 #define	IMM_LEN ( \
-	2 * EQ_ESIZE \
+	2 * EQ_HC_SIZE \
 	- sizeof (struct fw_eth_tx_pkt_wr) \
 	- sizeof (struct cpl_tx_pkt_core))
 
@@ -2100,7 +2465,8 @@ get_frame_txinfo(struct sge_txq *txq, mblk_t **fp, struct txinfo *txinfo,
 		bzero(&txinfo->meoi, sizeof (txinfo->meoi));
 	}
 
-start:	txinfo->nsegs = 0;
+start:
+	txinfo->nsegs = 0;
 	txinfo->hdls_used = 0;
 	txinfo->txb_used = 0;
 	txinfo->len = 0;
@@ -2115,10 +2481,10 @@ start:	txinfo->nsegs = 0;
 	m = *fp;
 
 	if (n >= TX_SGL_SEGS || ((flags & HW_LSO) && MBLKL(m) < 50)) {
-		txq->pullup_early++;
+		txq->stats.pullup_early++;
 		m = msgpullup(*fp, -1);
 		if (m == NULL) {
-			txq->pullup_failed++;
+			txq->stats.pullup_failed++;
 			return (E2BIG);	/* (*fp) left as it was */
 		}
 		freemsg(*fp);
@@ -2150,7 +2516,7 @@ start:	txinfo->nsegs = 0;
 		if (rc == E2BIG ||
 		    (txinfo->nsegs == TX_SGL_SEGS && m->b_cont)) {
 
-			txq->pullup_late++;
+			txq->stats.pullup_late++;
 			m = msgpullup(*fp, -1);
 			if (m != NULL) {
 				free_txinfo_resources(txq, txinfo);
@@ -2160,7 +2526,7 @@ start:	txinfo->nsegs = 0;
 				goto start;
 			}
 
-			txq->pullup_failed++;
+			txq->stats.pullup_failed++;
 			rc = E2BIG;
 		}
 
@@ -2170,9 +2536,8 @@ start:	txinfo->nsegs = 0;
 		}
 	}
 
-	ASSERT(txinfo->nsegs > 0 && txinfo->nsegs <= TX_SGL_SEGS);
-
 done:
+	ASSERT(txinfo->nsegs > 0 && txinfo->nsegs <= TX_SGL_SEGS);
 
 	/*
 	 * Store the # of flits required to hold this frame's SGL in nflits.  An
@@ -2222,7 +2587,7 @@ copy_into_txb(struct sge_txq *txq, mblk_t *m, int len, struct txinfo *txinfo)
 	TXQ_LOCK_ASSERT_OWNED(txq);	/* will manipulate txb */
 
 	if (!fits_in_txb(txq, len, &waste)) {
-		txq->txb_full++;
+		txq->stats.txb_full++;
 		return (ENOMEM);
 	}
 
@@ -2293,7 +2658,7 @@ add_mblk(struct sge_txq *txq, struct txinfo *txinfo, mblk_t *m, int len)
 	TXQ_LOCK_ASSERT_OWNED(txq);	/* will manipulate dhdls */
 
 	if (txq->tx_dhdl_avail == 0) {
-		txq->dma_hdl_failed++;
+		txq->stats.dma_hdl_failed++;
 		return (ENOMEM);
 	}
 
@@ -2302,7 +2667,7 @@ add_mblk(struct sge_txq *txq, struct txinfo *txinfo, mblk_t *m, int len)
 	    DDI_DMA_WRITE | DDI_DMA_STREAMING, DDI_DMA_DONTWAIT, NULL, &cookie,
 	    &ccount);
 	if (rc != DDI_DMA_MAPPED) {
-		txq->dma_map_failed++;
+		txq->stats.dma_map_failed++;
 
 		ASSERT(rc != DDI_DMA_INUSE && rc != DDI_DMA_PARTIAL_MAP);
 
@@ -2372,7 +2737,7 @@ static int
 add_to_txpkts(struct sge_txq *txq, struct txpkts *txpkts, mblk_t *m,
     struct txinfo *txinfo)
 {
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
 	int can_coalesce;
 	struct tx_sdesc *txsd;
 	uint8_t flits;
@@ -2381,10 +2746,10 @@ add_to_txpkts(struct sge_txq *txq, struct txpkts *txpkts, mblk_t *m,
 	ASSERT(m->b_next == NULL);
 
 	if (txpkts->npkt > 0) {
-		flits = TXPKTS_PKT_HDR + txinfo->nflits;
+		flits = TXPKTS_PKT_HDR_FLITS + txinfo->nflits;
 		can_coalesce = (txinfo->flags & HW_LSO) == 0 &&
-		    txpkts->nflits + flits <= TX_WR_FLITS &&
-		    txpkts->nflits + flits <= eq->avail * 8 &&
+		    txpkts->nflits + flits <= TX_WR_MAX_FLITS &&
+		    txpkts->nflits + flits <= EQ_HC_TO_FLITS(eq->tse_avail) &&
 		    txpkts->plen + txinfo->len < 65536;
 
 		if (can_coalesce != 0) {
@@ -2394,7 +2759,7 @@ add_to_txpkts(struct sge_txq *txq, struct txpkts *txpkts, mblk_t *m,
 			txpkts->nflits += flits;
 			txpkts->plen += txinfo->len;
 
-			txsd = &txq->sdesc[eq->pidx];
+			txsd = &txq->sdesc[eq->tse_pidx];
 			txsd->txb_used += txinfo->txb_used;
 			txsd->hdls_used += txinfo->hdls_used;
 
@@ -2424,9 +2789,15 @@ add_to_txpkts(struct sge_txq *txq, struct txpkts *txpkts, mblk_t *m,
 	ASSERT(txpkts->npkt == 0);
 	ASSERT(txinfo->len < 65536);
 
-	flits = TXPKTS_WR_HDR + txinfo->nflits;
+	flits = TXPKTS_WR_HDR_FLITS + txinfo->nflits;
+
+	/*
+	 * We can coalesce if this is non-LSO and the number of flits required
+	 * is both less than or equal to the maximum flits allowed for a single
+	 * WR and less than or equal to the number of flits currently available.
+	 */
 	can_coalesce = (txinfo->flags & HW_LSO) == 0 &&
-	    flits <= eq->avail * 8 && flits <= TX_WR_FLITS;
+	    flits <= EQ_HC_TO_FLITS(eq->tse_avail) && flits <= TX_WR_MAX_FLITS;
 
 	if (can_coalesce == 0)
 		return (EINVAL);
@@ -2434,13 +2805,14 @@ add_to_txpkts(struct sge_txq *txq, struct txpkts *txpkts, mblk_t *m,
 	/*
 	 * Start a fresh coalesced tx WR with m as the first frame in it.
 	 */
+	t4_eq_host_credit_t *hc = t4_eq_credit(eq, eq->tse_pidx);
 	txpkts->tail = m;
 	txpkts->npkt = 1;
 	txpkts->nflits = flits;
-	txpkts->flitp = &eq->desc[eq->pidx].flit[2];
+	txpkts->flitp = &hc->flit[2];
 	txpkts->plen = txinfo->len;
 
-	txsd = &txq->sdesc[eq->pidx];
+	txsd = &txq->sdesc[eq->tse_pidx];
 	txsd->mp_head = txsd->mp_tail = m;
 	txsd->txb_used = txinfo->txb_used;
 	txsd->hdls_used = txinfo->hdls_used;
@@ -2449,63 +2821,72 @@ add_to_txpkts(struct sge_txq *txq, struct txpkts *txpkts, mblk_t *m,
 }
 
 static inline void
-t4_tx_incr_pending(struct sge_txq *txq, uint_t ndesc)
+t4_tx_incr_pending(struct sge_txq *txq, uint16_t ncredits)
 {
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
 
 	TXQ_LOCK_ASSERT_OWNED(txq);
-	ASSERT3U(ndesc, !=, 0);
-	ASSERT3U(eq->avail, >=, ndesc);
-
-	eq->pending += ndesc;
-	eq->avail -= ndesc;
-	eq->pidx += ndesc;
-	if (eq->pidx >= eq->cap) {
-		eq->pidx -= eq->cap;
+	ASSERT3U(ncredits, !=, 0);
+	ASSERT3U(eq->tse_avail, >=, ncredits);
+
+	eq->tse_pending += ncredits;
+	eq->tse_avail -= ncredits;
+	eq->tse_pidx += ncredits;
+	if (eq->tse_pidx >= eq->tse_qsize) {
+		eq->tse_pidx -= eq->tse_qsize;
 	}
+
+	ASSERT3U(eq->tse_pidx, <, eq->tse_qsize);
+	ASSERT3U(eq->tse_pending, <=, eq->tse_qsize - 1);
 }
 
 /*
- * Note that write_txpkts_wr can never run out of hardware descriptors (but
- * write_txpkt_wr can).  add_to_txpkts ensures that a frame is accepted for
- * coalescing only if sufficient hardware descriptors are available.
+ * Note that write_txpkts_wr() can never run out of host credits (but
+ * write_txpkt_wr() can). add_to_txpkts() ensures that a frame is accepted for
+ * coalescing only if sufficient host credits are available.
  */
 static void
 write_txpkts_wr(struct sge_txq *txq, struct txpkts *txpkts)
 {
-	struct sge_eq *eq = &txq->eq;
-	struct fw_eth_tx_pkts_wr *wr;
-	struct tx_sdesc *txsd;
-	uint32_t ctrl;
-	uint16_t ndesc;
+	t4_sge_eq_t *eq = &txq->eq;
 
 	TXQ_LOCK_ASSERT_OWNED(txq);	/* pidx, avail */
 
-	ndesc = howmany(txpkts->nflits, 8);
+	struct fw_eth_tx_pkts_wr *wr = t4_eq_credit(eq, eq->tse_pidx);
+	const uint16_t ncredits = EQ_FLITS_TO_HC(txpkts->nflits);
+	ASSERT3U(ncredits, <=, eq->tse_avail);
 
-	wr = (void *)&eq->desc[eq->pidx];
-	wr->op_pkd = cpu_to_be32(V_FW_WR_OP(FW_ETH_TX_PKTS_WR) |
-	    V_FW_WR_IMMDLEN(0)); /* immdlen does not matter in this WR */
-	ctrl = V_FW_WR_LEN16(howmany(txpkts->nflits, 2));
-	if (eq->avail == ndesc)
-		ctrl |= F_FW_WR_EQUEQ | F_FW_WR_EQUIQ;
-	wr->equiq_to_len16 = cpu_to_be32(ctrl);
-	wr->plen = cpu_to_be16(txpkts->plen);
+	/* The immdlen value does not matter for this WR. */
+	wr->op_pkd = BE_32(V_FW_WR_OP(FW_ETH_TX_PKTS_WR) | V_FW_WR_IMMDLEN(0));
+
+	/*
+	 * If all remaining credits are consumed by this WR, then request an EQ
+	 * status update to both the EQ status page and the associated ingress
+	 * queue entry.
+	 *
+	 * See §29.10 FW_ETH_TX_PKTS_WR of the T4 Firmware Interface
+	 * Specification.
+	 */
+	const uint32_t update_bits = (eq->tse_avail == ncredits) ?
+	    (F_FW_WR_EQUEQ | F_FW_WR_EQUIQ) : 0;
+	wr->equiq_to_len16 = BE_32(V_FW_WR_LEN16(howmany(txpkts->nflits, 2)) |
+	    update_bits);
+	wr->r3 = 0;
+	wr->plen = BE_16(txpkts->plen);
 	wr->npkt = txpkts->npkt;
-	wr->r3 = wr->type = 0;
+	wr->type = 0;
 
 	/* Everything else already written */
+	struct tx_sdesc *txsd = &txq->sdesc[eq->tse_pidx];
+	txsd->credits_used = ncredits;
 
-	txsd = &txq->sdesc[eq->pidx];
-	txsd->desc_used = ndesc;
-
-	txq->txb_used += txsd->txb_used / TXB_CHUNK;
-	txq->hdl_used += txsd->hdls_used;
+	txq->stats.txb_used += txsd->txb_used / TXB_CHUNK;
+	txq->stats.hdl_used += txsd->hdls_used;
 
-	t4_tx_incr_pending(txq, ndesc);
+	t4_tx_incr_pending(txq, ncredits);
 
-	txq->txpkts_pkts += txpkts->npkt;
-	txq->txpkts_wrs++;
+	txq->stats.txpkts_pkts += txpkts->npkt;
+	txq->stats.txpkts_wrs++;
 	txpkts->npkt = 0;	/* emptied */
 }
 
@@ -2621,12 +3002,11 @@ static int
 write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
     struct txinfo *txinfo)
 {
-	struct sge_eq *eq = &txq->eq;
-	struct fw_eth_tx_pkt_wr *wr;
+	t4_sge_eq_t *eq = &txq->eq;
 	struct cpl_tx_pkt_core *cpl;
 	uint32_t ctrl;	/* used in many unrelated places */
 	uint64_t ctrl1;
-	int nflits, ndesc;
+	uint16_t nflits = 0;
 	struct tx_sdesc *txsd;
 	caddr_t dst;
 	const mac_ether_offload_info_t *meoi = &txinfo->meoi;
@@ -2638,28 +3018,38 @@ write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
 	 */
 	ctrl = sizeof (struct cpl_tx_pkt_core);
 	if (txinfo->flags & HW_LSO) {
-		nflits = TXPKT_LSO_WR_HDR;
+		nflits = TXPKT_LSO_WR_HDR_FLITS;
 		ctrl += sizeof (struct cpl_tx_pkt_lso_core);
 	} else {
-		nflits = TXPKT_WR_HDR;
+		nflits = TXPKT_WR_HDR_FLITS;
 	}
 	if (txinfo->nsegs > 0)
 		nflits += txinfo->nflits;
 	else {
-		nflits += howmany(txinfo->len, 8);
+		nflits += howmany(txinfo->len, FLIT_NUM_BYTES);
 		ctrl += txinfo->len;
 	}
-	ndesc = howmany(nflits, 8);
-	if (ndesc > eq->avail)
+
+	ASSERT3U(nflits, >, 0);
+
+	const uint16_t ncredits = EQ_FLITS_TO_HC(nflits);
+	if (ncredits > eq->tse_avail)
 		return (ENOMEM);
 
 	/* Firmware work request header */
-	wr = (void *)&eq->desc[eq->pidx];
+	struct fw_eth_tx_pkt_wr *wr = t4_eq_credit(eq, eq->tse_pidx);
 	wr->op_immdlen = cpu_to_be32(V_FW_WR_OP(FW_ETH_TX_PKT_WR) |
 	    V_FW_WR_IMMDLEN(ctrl));
 	ctrl = V_FW_WR_LEN16(howmany(nflits, 2));
-	if (eq->avail == ndesc)
+
+	/*
+	 * If all remaining credits are consumed by this WR, then request an EQ
+	 * status update to both the EQ status page and the associated ingress
+	 * queue entry.
+	 */
+	if (ncredits == eq->tse_avail)
 		ctrl |= F_FW_WR_EQUEQ | F_FW_WR_EQUIQ;
+
 	wr->equiq_to_len16 = cpu_to_be32(ctrl);
 	wr->r3 = 0;
 
@@ -2703,7 +3093,7 @@ write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
 
 		cpl = (void *)(lso + 1);
 
-		txq->tso_wrs++;
+		txq->stats.tso_wrs++;
 	} else {
 		cpl = (void *)(wr + 1);
 	}
@@ -2712,14 +3102,14 @@ write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
 	switch (csum_to_ctrl(txinfo,
 	    CHELSIO_CHIP_VERSION(pi->adapter->params.chip), &ctrl1)) {
 	case COS_SUCCESS:
-		txq->txcsum++;
+		txq->stats.txcsum++;
 		break;
 	case COS_FAIL:
 		/*
 		 * Packet will be going out with checksums which are probably
 		 * wrong but there is little we can do now.
 		 */
-		txq->csum_failed++;
+		txq->stats.csum_failed++;
 		break;
 	default:
 		break;
@@ -2733,21 +3123,21 @@ write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
 	cpl->ctrl1 = cpu_to_be64(ctrl1);
 
 	/* Software descriptor */
-	txsd = &txq->sdesc[eq->pidx];
+	txsd = &txq->sdesc[eq->tse_pidx];
 	txsd->mp_head = txsd->mp_tail = m;
 	txsd->txb_used = txinfo->txb_used;
 	txsd->hdls_used = txinfo->hdls_used;
-	txsd->desc_used = ndesc;
+	txsd->credits_used = ncredits;
 
-	txq->txb_used += txinfo->txb_used / TXB_CHUNK;
-	txq->hdl_used += txinfo->hdls_used;
+	txq->stats.txb_used += txinfo->txb_used / TXB_CHUNK;
+	txq->stats.hdl_used += txinfo->hdls_used;
 
-	t4_tx_incr_pending(txq, ndesc);
+	t4_tx_incr_pending(txq, ncredits);
 
 	/* SGL */
 	dst = (void *)(cpl + 1);
 	if (txinfo->nsegs > 0) {
-		txq->sgl_wrs++;
+		txq->stats.sgl_wrs++;
 		copy_to_txd(eq, (void *)&txinfo->sgl, &dst, txinfo->nflits * 8);
 
 		/* Need to zero-pad to a 16 byte boundary if not on one */
@@ -2755,7 +3145,7 @@ write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
 			*(uint64_t *)dst = 0;
 
 	} else {
-		txq->imm_wrs++;
+		txq->stats.imm_wrs++;
 #ifdef DEBUG
 		ctrl = txinfo->len;
 #endif
@@ -2768,17 +3158,17 @@ write_txpkt_wr(struct port_info *pi, struct sge_txq *txq, mblk_t *m,
 		ASSERT(ctrl == 0);
 	}
 
-	txq->txpkt_wrs++;
+	txq->stats.txpkt_wrs++;
 	return (0);
 }
 
 static void
 t4_write_flush_wr(struct sge_txq *txq)
 {
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
 
 	EQ_LOCK_ASSERT_OWNED(eq);
-	ASSERT(eq->avail > 0);
+	ASSERT3U(eq->tse_avail, >, 0);
 
 	const struct fw_eq_flush_wr wr = {
 		.opcode = FW_EQ_FLUSH_WR,
@@ -2786,20 +3176,31 @@ t4_write_flush_wr(struct sge_txq *txq)
 		    V_FW_WR_LEN16(sizeof (struct fw_eq_flush_wr) / 16) |
 		    F_FW_WR_EQUEQ | F_FW_WR_EQUIQ),
 	};
-	*(struct fw_eq_flush_wr *)&eq->desc[eq->pidx] = wr;
+	*(struct fw_eq_flush_wr *)t4_eq_credit(eq, eq->tse_pidx) = wr;
 
 	const struct tx_sdesc txsd = {
 		.mp_head = NULL,
 		.mp_tail = NULL,
 		.txb_used = 0,
 		.hdls_used = 0,
-		.desc_used = 1,
+		.credits_used = 1,
 	};
-	txq->sdesc[eq->pidx] = txsd;
+	txq->sdesc[eq->tse_pidx] = txsd;
 
 	t4_tx_incr_pending(txq, 1);
 }
 
+/*
+ * Increment the flit pointer by the given number of bytes.
+ */
+static inline void *
+t4_incr_flit(void *flitp, size_t num_bytes)
+{
+	/* A flit should always start on an 8-byte boundary. */
+	ASSERT0(((uintptr_t)flitp + num_bytes) & 0x7);
+	return ((void *)((caddr_t)(flitp) + (num_bytes)));
+}
+
 static inline void
 write_ulp_cpl_sgl(struct port_info *pi, struct sge_txq *txq,
     struct txpkts *txpkts, struct txinfo *txinfo)
@@ -2807,27 +3208,25 @@ write_ulp_cpl_sgl(struct port_info *pi, struct sge_txq *txq,
 	struct ulp_txpkt *ulpmc;
 	struct ulptx_idata *ulpsc;
 	struct cpl_tx_pkt_core *cpl;
-	uintptr_t flitp, start, end;
+	void *flitp = txpkts->flitp;
 	uint64_t ctrl;
 	caddr_t dst;
+	const uintptr_t end = (uintptr_t)txq->eq.tse_spg;
 
-	ASSERT(txpkts->npkt > 0);
-
-	start = (uintptr_t)txq->eq.desc;
-	end = (uintptr_t)txq->eq.spg;
+	ASSERT3U(txpkts->npkt, >, 0);
 
 	/* Checksum offload */
 	switch (csum_to_ctrl(txinfo,
 	    CHELSIO_CHIP_VERSION(pi->adapter->params.chip), &ctrl)) {
 	case COS_SUCCESS:
-		txq->txcsum++;
+		txq->stats.txcsum++;
 		break;
 	case COS_FAIL:
 		/*
 		 * Packet will be going out with checksums which are probably
 		 * wrong but there is little we can do now.
 		 */
-		txq->csum_failed++;
+		txq->stats.csum_failed++;
 		break;
 	default:
 		break;
@@ -2840,113 +3239,131 @@ write_ulp_cpl_sgl(struct port_info *pi, struct sge_txq *txq,
 	 * bytes each), and that it can not wrap around in the middle of the
 	 * cpl_tx_pkt_core either.
 	 */
-	flitp = (uintptr_t)txpkts->flitp;
-	ASSERT((flitp & 0xf) == 0);
+	ASSERT0((uintptr_t)flitp & 0xf);
+	ASSERT3U((uintptr_t)flitp + sizeof (*ulpmc), <=, end);
 
 	/* ULP master command */
-	ulpmc = (void *)flitp;
+	ulpmc = flitp;
 	ulpmc->cmd_dest = htonl(V_ULPTX_CMD(ULP_TX_PKT) | V_ULP_TXPKT_DEST(0));
 	ulpmc->len = htonl(howmany(sizeof (*ulpmc) + sizeof (*ulpsc) +
-	    sizeof (*cpl) + 8 * txinfo->nflits, 16));
+	    sizeof (*cpl) + FLITS_TO_BYTES(txinfo->nflits), 16));
+
+	flitp = t4_incr_flit(flitp, sizeof (*ulpmc));
+
+	/* We cannot wrap-around between the ULPTX master and subcommand. */
+	ASSERT3U((uintptr_t)flitp, <, end);
+	ASSERT3U((uintptr_t)flitp + sizeof (*ulpsc), <=, end);
 
 	/* ULP subcommand */
-	ulpsc = (void *)(ulpmc + 1);
+	ulpsc = flitp;
 	ulpsc->cmd_more = cpu_to_be32(V_ULPTX_CMD((u32)ULP_TX_SC_IMM) |
 	    F_ULP_TX_SC_MORE);
 	ulpsc->len = cpu_to_be32(sizeof (struct cpl_tx_pkt_core));
 
-	flitp += sizeof (*ulpmc) + sizeof (*ulpsc);
-	if (flitp == end)
-		flitp = start;
+	flitp = t4_incr_flit(flitp, sizeof (*ulpsc));
+
+	/* If we have reached the end, go back to the start of the ring. */
+	if ((uintptr_t)flitp == end)
+		flitp = txq->eq.tse_ring;
 
 	/* CPL_TX_PKT_XT */
-	cpl = (void *)flitp;
+	cpl = flitp;
 	cpl->ctrl0 = cpu_to_be32(V_TXPKT_OPCODE(CPL_TX_PKT_XT) |
 	    V_TXPKT_INTF(pi->tx_chan) | V_TXPKT_PF(pi->adapter->pf));
 	cpl->pack = 0;
 	cpl->len = cpu_to_be16(txinfo->len);
 	cpl->ctrl1 = cpu_to_be64(ctrl);
 
-	flitp += sizeof (*cpl);
-	if (flitp == end)
-		flitp = start;
+	flitp = t4_incr_flit(flitp, sizeof (*cpl));
+
+	/* The CPL cannot wrap-around the end. */
+	ASSERT3U((uintptr_t)flitp, <=, end);
+
+	if ((uintptr_t)flitp == end)
+		flitp = txq->eq.tse_ring;
 
 	/* SGL for this frame */
 	dst = (caddr_t)flitp;
-	copy_to_txd(&txq->eq, (void *)&txinfo->sgl, &dst, txinfo->nflits * 8);
-	flitp = (uintptr_t)dst;
+	copy_to_txd(&txq->eq, (void *)&txinfo->sgl, &dst,
+	    FLITS_TO_BYTES(txinfo->nflits));
+	flitp = (void *)dst;
 
 	/* Zero pad and advance to a 16 byte boundary if not already at one. */
-	if (flitp & 0xf) {
-
-		/* no matter what, flitp should be on an 8 byte boundary */
-		ASSERT((flitp & 0x7) == 0);
+	if (((uintptr_t)flitp & 0xf) != 0) {
+		/* A flit should always be on an 8 byte boundary. */
+		ASSERT(((uintptr_t)flitp & 0x7) == 0);
 
 		*(uint64_t *)flitp = 0;
-		flitp += sizeof (uint64_t);
+		flitp = t4_incr_flit(flitp, FLIT_NUM_BYTES);
 		txpkts->nflits++;
 	}
 
-	if (flitp == end)
-		flitp = start;
+	ASSERT0((uintptr_t)flitp & 0xf);
+
+	/*
+	 * The SGL can wrap-around, but lets make sure we stayed within the
+	 * ring.
+	 */
+	ASSERT3U((uintptr_t)flitp, <=, end);
+
+	if ((uintptr_t)flitp == end)
+		flitp = txq->eq.tse_ring;
 
-	txpkts->flitp = (void *)flitp;
+	txpkts->flitp = flitp;
 }
 
 static inline void
-copy_to_txd(struct sge_eq *eq, caddr_t from, caddr_t *to, int len)
+copy_to_txd(t4_sge_eq_t *eq, caddr_t from, caddr_t *to, size_t len)
 {
-	if ((uintptr_t)(*to) + len <= (uintptr_t)eq->spg) {
+	/*
+	 * Technically the maximum WR size is lower, but this assert is just to
+	 * make sure nothing funky is going on with len. We subtract one from
+	 * the qsize because you can never totally fill the queue.
+	 */
+	ASSERT3U(len, <=, FLITS_TO_BYTES(EQ_HC_TO_FLITS(eq->tse_qsize - 1)));
+
+	if ((uintptr_t)(*to) + len <= (uintptr_t)eq->tse_spg) {
 		bcopy(from, *to, len);
 		(*to) += len;
 	} else {
-		int portion = (uintptr_t)eq->spg - (uintptr_t)(*to);
+		/*
+		 * The number of bytes left before the end of the ring (which is
+		 * the status page).
+		 */
+		size_t portion = (uintptr_t)eq->tse_spg - (uintptr_t)(*to);
 
+		ASSERT3U(portion, <, len);
 		bcopy(from, *to, portion);
 		from += portion;
 		portion = len - portion;	/* remaining */
-		bcopy(from, (void *)eq->desc, portion);
-		(*to) = (caddr_t)eq->desc + portion;
+		bcopy(from, eq->tse_ring, portion);
+		(*to) = (caddr_t)eq->tse_ring + portion;
 	}
 }
 
 static void
 t4_tx_ring_db(struct sge_txq *txq)
 {
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
 	struct adapter *sc = txq->port->adapter;
 	int val, db_mode;
-	t4_doorbells_t db = eq->doorbells;
+	t4_doorbells_t db = eq->tse_doorbells;
 
 	EQ_LOCK_ASSERT_OWNED(eq);
 
-	if (eq->pending > 1)
+	/*
+	 * A Write-Combining Work Request implicitly uses a single credit and
+	 * only a single credit. If we have produced more than one credit, then
+	 * fallback to the Write-Combining UDB, then plain UDB, and finally KDB.
+	 */
+	if (eq->tse_pending > 1)
 		db &= ~DOORBELL_WCWR;
 
-	if (eq->pending > eq->pidx) {
-		int offset = eq->cap - (eq->pending - eq->pidx);
-
-		/* pidx has wrapped around since last doorbell */
-
-		(void) ddi_dma_sync(eq->desc_dhdl,
-		    offset * sizeof (struct tx_desc), 0,
-		    DDI_DMA_SYNC_FORDEV);
-		(void) ddi_dma_sync(eq->desc_dhdl,
-		    0, eq->pidx * sizeof (struct tx_desc),
-		    DDI_DMA_SYNC_FORDEV);
-	} else if (eq->pending > 0) {
-		(void) ddi_dma_sync(eq->desc_dhdl,
-		    (eq->pidx - eq->pending) * sizeof (struct tx_desc),
-		    eq->pending * sizeof (struct tx_desc),
-		    DDI_DMA_SYNC_FORDEV);
-	}
+	(void) ddi_dma_sync(eq->tse_ring_dhdl, 0, 0, DDI_DMA_SYNC_FORDEV);
 
 	membar_producer();
 
-	if (t4_cver_eq(sc, CHELSIO_T4))
-		val = V_PIDX(eq->pending);
-	else
-		val = V_PIDX_T5(eq->pending);
+	val = V_PIDX(eq->tse_pending);
 
 	db_mode = (1 << (ffs(db) - 1));
 	switch (db_mode) {
@@ -2957,17 +3374,20 @@ t4_tx_ring_db(struct sge_txq *txq)
 			 * (udb_qid is always 0).  Only queues with
 			 * doorbell segments can do WCWR.
 			 */
-			ASSERT(eq->udb_qid == 0 && eq->pending == 1);
+			ASSERT(eq->tse_udb_qid == 0 && eq->tse_pending == 1);
 
-			const uint_t desc_idx =
-			    eq->pidx != 0 ? eq->pidx - 1 : eq->cap - 1;
-			uint64_t *src = (uint64_t *)&eq->desc[desc_idx];
+			const uint16_t credit_idx = eq->tse_pidx != 0 ?
+			    eq->tse_pidx - 1 : eq->tse_qsize - 1;
+			uint64_t *src = t4_eq_credit(eq, credit_idx);
 			volatile uint64_t *dst =
-			    (uint64_t *)(eq->udb + UDBS_WR_OFFSET);
+			    (uint64_t *)(eq->tse_udb + UDBS_WR_OFFSET);
 
-			/* Copy the 8 flits of the TX descriptor to the DB */
+			/*
+			 * Copy the 8 flits of the host credit to the UDB WCWR
+			 * space (the second 64 bytes of the 128 byte segment).
+			 */
 			const uint_t flit_count =
-			    sizeof (struct tx_desc) / sizeof (uint64_t);
+			    sizeof (t4_eq_host_credit_t) / sizeof (uint64_t);
 			for (uint_t i = 0; i < flit_count; i++) {
 				/*
 				 * Perform the copy directly through the BAR
@@ -2986,50 +3406,59 @@ t4_tx_ring_db(struct sge_txq *txq)
 		case DOORBELL_UDB:
 		case DOORBELL_UDBWC:
 			ddi_put32(sc->bar2_hdl,
-			    (uint32_t *)(eq->udb + UDBS_DB_OFFSET),
-			    LE_32(V_QID(eq->udb_qid) | val));
+			    (uint32_t *)(eq->tse_udb + UDBS_DB_OFFSET),
+			    LE_32(V_QID(eq->tse_udb_qid) | val));
 			membar_producer();
 			break;
 
 		case DOORBELL_KDB:
 			t4_write_reg(sc, MYPF_REG(A_SGE_PF_KDOORBELL),
-			    V_QID(eq->cntxt_id) | val);
+			    V_QID(eq->tse_cntxt_id) | val);
 			break;
 	}
 
-	eq->pending = 0;
+	eq->tse_pending = 0;
 }
 
 /*
- * Reclaim consumed descriptors from egress queue.  This will be capped at an
- * upper bound of `howmany`.  The corresponding mblks will be freed inline,
- * unless a non-NULL `defer_freemp` is provided, in which case the to-be-freed
- * mblk chain will be provided to the caller.
+ * Attempt to reclaim consumed host credits from the given Tx EQ. The number of
+ * credits to reclaim is specified by 'howmany', but that value is clamped down
+ * to the number of credits available for reclaim if it is too large. The mblks
+ * associated with the reclaimed credits are freed inline unless a non-NULL
+ * 'defer_freemp' is provided; in that case an mblk chain is provided to the
+ * caller who is now responsible for freeing.
  *
- * Returns the number of descriptors which underwent reclamation.
+ * Returns the number of reclaimed host credits.
+ *
+ * When debugging/analyzing this code it is important to remember that host
+ * credits != mblks.
  */
-static uint_t
-t4_tx_reclaim_descs(struct sge_txq *txq, uint_t howmany, mblk_t **defer_freemp)
+static uint16_t
+t4_tx_reclaim_credits(struct sge_txq *txq, uint16_t howmany,
+    mblk_t **defer_freemp)
 {
-	struct sge_eq *eq = &txq->eq;
+	t4_sge_eq_t *eq = &txq->eq;
 
 	EQ_LOCK_ASSERT_OWNED(eq);
 
-	const uint_t cur_cidx = BE_16(eq->spg->cidx);
-	const uint_t reclaim_avail = (cur_cidx >= eq->cidx) ?
-	    (cur_cidx - eq->cidx) : (cur_cidx + eq->cap - eq->cidx);
+	const uint16_t cur_cidx = BE_16(eq->tse_spg->cidx);
+	const uint16_t reclaim_avail = (cur_cidx >= eq->tse_cidx) ?
+	    (cur_cidx - eq->tse_cidx) :
+	    (cur_cidx + eq->tse_qsize - eq->tse_cidx);
 
 	if (reclaim_avail == 0) {
 		return (0);
 	}
 
-	uint_t txb_freed = 0, hdl_freed = 0, reclaimed = 0;
+	uint_t txb_freed = 0, hdl_freed = 0;
+	uint16_t reclaimed = 0;
+
 	do {
-		struct tx_sdesc *txsd = &txq->sdesc[eq->cidx];
-		const uint_t ndesc = txsd->desc_used;
+		struct tx_sdesc *txsd = &txq->sdesc[eq->tse_cidx];
+		const uint16_t ncredits = txsd->credits_used;
 
 		/* Firmware doesn't return "partial" credits. */
-		ASSERT3U(reclaimed + ndesc, <=, reclaim_avail);
+		ASSERT3U(reclaimed + ncredits, <=, reclaim_avail);
 
 		if (txsd->mp_head != NULL) {
 			/*
@@ -3060,24 +3489,24 @@ t4_tx_reclaim_descs(struct sge_txq *txq, uint_t howmany, mblk_t **defer_freemp)
 			 */
 			ASSERT0(txsd->txb_used);
 			ASSERT0(txsd->hdls_used);
-			ASSERT3U(ndesc, ==, 1);
+			ASSERT3U(ncredits, ==, 1);
 		}
 
 		txb_freed += txsd->txb_used;
 		hdl_freed += txsd->hdls_used;
-		reclaimed += ndesc;
+		reclaimed += ncredits;
 
-		eq->cidx += ndesc;
-		if (eq->cidx >= eq->cap) {
-			eq->cidx -= eq->cap;
+		eq->tse_cidx += ncredits;
+		if (eq->tse_cidx >= eq->tse_qsize) {
+			eq->tse_cidx -= eq->tse_qsize;
 		}
 	} while (reclaimed < reclaim_avail && reclaimed < howmany);
 
-	eq->avail += reclaimed;
+	eq->tse_avail += reclaimed;
 	txq->txb_avail += txb_freed;
 	txq->tx_dhdl_avail += hdl_freed;
 
-	ASSERT3U(eq->avail, <, eq->cap);
+	ASSERT3U(eq->tse_avail, <, eq->tse_qsize);
 	ASSERT3U(txq->tx_dhdl_avail, <=, txq->tx_dhdl_total);
 
 	for (; hdl_freed; hdl_freed--) {
@@ -3090,11 +3519,11 @@ t4_tx_reclaim_descs(struct sge_txq *txq, uint_t howmany, mblk_t **defer_freemp)
 }
 
 static int
-t4_handle_cpl_msg(struct sge_iq *iq, const struct rss_header *rss, mblk_t *mp)
+t4_handle_cpl_msg(t4_sge_iq_t *iq, const struct rss_header *rss, mblk_t *mp)
 {
 	const uint8_t opcode = rss->opcode;
 
-	DTRACE_PROBE4(t4__cpl_msg, struct sge_iq *, iq, uint8_t, opcode,
+	DTRACE_PROBE4(t4__cpl_msg, t4_sge_iq_t *, iq, uint8_t, opcode,
 	    const struct rss_header *, rss, mblk_t *, mp);
 
 	switch (opcode) {
@@ -3107,9 +3536,16 @@ t4_handle_cpl_msg(struct sge_iq *iq, const struct rss_header *rss, mblk_t *mp)
 		t4_sge_egr_update(iq, rss);
 		return (0);
 	case CPL_RX_PKT:
-		return (t4_eth_rx(iq, rss, mp));
+		/*
+		 * Packet RX is expected to be handled in t4_process_rx_iq().
+		 * CPL messages of such a type should not make it here.
+		 */
+		cxgb_printf(iq->tsi_adapter->dip, CE_WARN,
+		    "unexpected unhandled CPL_RX_PKT msg");
+		freemsg(mp);
+		return (0);
 	default:
-		cxgb_printf(iq->adapter->dip, CE_WARN,
+		cxgb_printf(iq->tsi_adapter->dip, CE_WARN,
 		    "unhandled CPL opcode 0x%02x", opcode);
 		if (mp != NULL) {
 			freemsg(mp);
@@ -3119,14 +3555,14 @@ t4_handle_cpl_msg(struct sge_iq *iq, const struct rss_header *rss, mblk_t *mp)
 }
 
 static int
-t4_handle_fw_msg(struct sge_iq *iq, const struct rss_header *rss)
+t4_handle_fw_msg(t4_sge_iq_t *iq, const struct rss_header *rss)
 {
 	const struct cpl_fw6_msg *cpl = (const void *)(rss + 1);
 	const uint8_t msg_type = cpl->type;
 	const struct rss_header *rss2;
-	struct adapter *sc = iq->adapter;
+	struct adapter *sc = iq->tsi_adapter;
 
-	DTRACE_PROBE3(t4__fw_msg, struct sge_iq *, iq, uint8_t, msg_type,
+	DTRACE_PROBE3(t4__fw_msg, t4_sge_iq_t *, iq, uint8_t, msg_type,
 	    const struct rss_header *, rss);
 
 	switch (msg_type) {
